//**********************
// Switch Function with only dsPIC30F2011 CQ board
// 
// (C)Copyright 2009 All rights reserved by Y.Onodera
// http://einst.hp.infoseek.co.jp
//**********************
#if defined(__dsPIC30F__)
#include <p30fxxxx.h>
#elif defined(__dsPIC33F__)
#include <p33Fxxxx.h>
#elif defined(__PIC24H__)
#include <p24Hxxxx.h>
#elif defined(__PIC24F__)
#include <p24Fxxxx.h>
#endif


#define SW1bit PORTBbits.RB0
#define SW2bit PORTBbits.RB1
#define SW3bit PORTBbits.RB2
#define SW4bit PORTBbits.RB3
#define SW5bit PORTBbits.RB4
#define SW6bit PORTBbits.RB5

extern int flag;
extern int mode;
extern int set;

void __attribute__((interrupt, no_auto_psv)) _CNInterrupt(void)
{
	if(flag==1){
		flag=0;
		if(SW1bit==0){
			++mode;
			if(mode>7){
				mode=0;
			}
		}
		if(SW2bit==0){
			if(set==0){
				set=1;
			}else{
				set=0;
			}
		}
		if(SW3bit==0){
		}
		if(SW4bit==0){
		}
		if(SW5bit==0){
		}
		if(SW6bit==0){
		}
	}

//	IFS0bits.CNIF = 0;
	_CNIF = 0;

}


void InitSW(){

	ADPCFGbits.PCFG0 = 1;	// set digital
	ADPCFGbits.PCFG1 = 1;	// set digital
	ADPCFGbits.PCFG2 = 1;	// set digital
	ADPCFGbits.PCFG3 = 1;	// set digital
	ADPCFGbits.PCFG4 = 1;	// set digital
	ADPCFGbits.PCFG5 = 1;	// set digital

	TRISBbits.TRISB0=0;	// set output
	TRISBbits.TRISB1=0;	// set output
	TRISBbits.TRISB2=0;	// set output
	TRISBbits.TRISB3=0;	// set output
	TRISBbits.TRISB4=0;	// set output
	TRISBbits.TRISB5=0;	// set output

	SW1bit=1;
	SW2bit=1;
	SW3bit=1;
	SW4bit=1;
	SW5bit=1;
	SW6bit=1;

	TRISBbits.TRISB0=1;	// set input
	TRISBbits.TRISB1=1;	// set input
	TRISBbits.TRISB2=1;	// set input
	TRISBbits.TRISB3=1;	// set input
	TRISBbits.TRISB4=1;	// set input
	TRISBbits.TRISB5=1;	// set input

	CNEN1bits.CN2IE=1;	// set interrupt enable
	CNEN1bits.CN3IE=1;	// set interrupt enable
	CNEN1bits.CN4IE=1;	// set interrupt enable
	CNEN1bits.CN5IE=1;	// set interrupt enable
	CNEN1bits.CN6IE=1;	// set interrupt enable
	CNEN1bits.CN7IE=1;	// set interrupt enable

	CNPU1bits.CN2PUE=1;	// set pullup
	CNPU1bits.CN3PUE=1;	// set pullup
	CNPU1bits.CN4PUE=1;	// set pullup
	CNPU1bits.CN5PUE=1;	// set pullup
	CNPU1bits.CN6PUE=1;	// set pullup
	CNPU1bits.CN7PUE=1;	// set pullup

	_CNIF = 0;
	_CNIE = 1;

}


int GetSW0(){

	ADPCFGbits.PCFG0 = 1;	// set digital
	TRISBbits.TRISB0=1;	// set input
	return PORTBbits.RB0;		// RB0
	// ON=0, OFF=1

}

int GetSW1(){

	ADPCFGbits.PCFG1 = 1;	// set digital
	TRISBbits.TRISB1=1;	// set input
	return PORTBbits.RB1;		// RB1
	// ON=0, OFF=1

}

int GetSW2(){

	ADPCFGbits.PCFG2 = 1;	// set digital
	TRISBbits.TRISB2=1;	// set input
	return PORTBbits.RB2;		// RB2
	// ON=0, OFF=1

}

int GetSW3(){

	ADPCFGbits.PCFG3 = 1;	// set digital
	TRISBbits.TRISB3=1;	// set input
	return PORTBbits.RB3;		// RB3
	// ON=0, OFF=1

}

int GetSW4(){

	ADPCFGbits.PCFG4 = 1;	// set digital
	TRISBbits.TRISB4=1;	// set input
	return PORTBbits.RB4;		// RB4
	// ON=0, OFF=1

}

int GetSW5(){

	ADPCFGbits.PCFG5 = 1;	// set digital
	TRISBbits.TRISB5=1;	// set input
	return PORTBbits.RB5;		// RB5
	// ON=0, OFF=1

}

